#ifndef GSLOOP_MISC_H
#define GSLOOP_MISC_H

#define LEVEL_ALL	4
#define LEVEL_INFO	3
#define LEVEL_WARN	2
#define LEVEL_ERROR	1

#ifndef MAX
#define MAX(x,y)	((x) > (y) ? (x) : (y))
#endif
#ifndef MIN
#define MIN(x,y)	((x) < (y) ? (x) : (y))
#endif

#ifndef ARRAY_SIZE
#define ARRAY_SIZE(x) (sizeof(x) / sizeof((x)[0]))
#endif

#ifdef DEBUG
#define dprintf(_level, _fmt, _arg...)			\
do {							\
	if (_gsl_debuglevel >= _level) {		\
		fprintf(stdout, _fmt, ##_arg);		\
		fflush(stdout);				\
	}						\
} while (0)
#else
#define dprintf(_level, _fmt, _arg...)			\
do { } while (0)
#endif

extern int _gsl_debuglevel;

#endif	/* !GSL_MISC_H */
