#ifndef LIBGSLOOP_H
#define LIBGSLOOP_H

#include <inttypes.h>
#include <sys/poll.h>

typedef struct {
	char		_data[160];
} gsloop_t;

typedef struct {
	char		_data[32];
} gsloop_server_t;

typedef struct {
	char		_data[16];
} gsloop_client_t;

typedef struct {
	char		_data[12];
} gsloop_common_t;


struct gsloop_event {
	int		fd;
	uint32_t	revents;
};


struct gsloop_attr {
	int		max_fd;
};

struct gsloop_server_attr {
	int		max_clients;
};


typedef struct gsloop_attr		gsloop_attr_t;
typedef struct gsloop_server_attr	gsloop_server_attr_t;
typedef struct gsloop_client_attr	gsloop_client_attr_t;
typedef struct gsloop_event		gsloop_event_t;


typedef int	(*gsloop_server_close_fn_t)	(gsloop_t		*gsloop,
						 gsloop_server_t	*gsloop_server);

typedef int	(*gsloop_server_add_fn_t)	(void *);

typedef int	(*gsloop_client_cb_fn_t)	(gsloop_t		*gsloop,
						 gsloop_client_t	*gsloop_client,
						 gsloop_event_t		*gsloop_event,
						 void			*data);



extern int gsloop_init			(gsloop_t			*gsloop,
					 gsloop_attr_t			*attr);

extern int gsloop_destroy		(gsloop_t			*gsloop);

extern int gsloop_dispatch		(gsloop_t			*gsloop,
					 unsigned int			timeout);

extern int gsloop_tcp_server_create	(gsloop_t			*gsloop_anon,
					 uint16_t			port,
					 gsloop_client_cb_fn_t		client_cb,
					 void				*data,
					 gsloop_server_attr_t		*attr);

extern int gsloop_client_close		(gsloop_t			*gsloop,
					 gsloop_client_t		*gsloop_client);

#endif	/* !LIBGSLOOP_H */
